﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Tests.ExposeFirstVisibleItemBehavior
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public ObservableCollection<string> Collection
        {
            get { return (ObservableCollection<string>)this.GetValue(CollectionProperty); }
            set { this.SetValue(CollectionProperty, value); }
        }

        public static readonly DependencyProperty CollectionProperty = DependencyProperty.Register(
          "Collection", typeof(ObservableCollection<string>), typeof(Window), new PropertyMetadata(new ObservableCollection<string>()));

        public MainWindow()
        {
            InitializeComponent();

            for (int i = 0; i < 1000; i++)
                Collection.Add(i.ToString());

            DataContext = this;
        }

        private void JumpToButton_Click(object sender, RoutedEventArgs e)
        {
            int index;
            if (int.TryParse(JumpToTextBox.Text, out index) && index >= 0 && index < Collection.Count)
            {
                Helpers.ListBoxExtension.SetFirstVisibleItem(VerticalListBox, Collection[index]);
                Helpers.ListBoxExtension.SetFirstVisibleItem(HorizontalListBox, Collection[index]);
            }
            else
            {
                MessageBox.Show(string.Format("Index ('{0}') is not valid.", JumpToTextBox.Text), 
                    "Error", MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }
    }
}
